﻿namespace TestProject
{
    /// <summary>
    /// 항목 제너레이터 인터페이스
    /// </summary>
    /// <typeparam name="TItem">항목 타입</typeparam>
    public interface IItemGenerator<TItem>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property

        #region 항목 수 - Count

        /// <summary>
        /// 항목 수
        /// </summary>
        int Count { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method

        #region 항목 생성하기 - CreateItem(index)

        /// <summary>
        /// 항목 생성하기
        /// </summary>
        /// <param name="index">인덱스</param>
        /// <returns>항목</returns>
        TItem CreateItem(int index);

        #endregion
    }
}